package org.jeecg.modules.stm.best.practices.controller;

import java.util.Arrays;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.modules.stm.best.practices.service.IStBestPracticesService;
import org.jeecg.modules.stm.best.practices.entity.StBestPractices;

import com.baomidou.mybatisplus.core.metadata.IPage;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;
 
 
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

/**
 * @Description: 行业实践应用
 * @Author: yzh
 * @Date:   2023-03-04
 * @Version: V1.0
 */
  
@RestController
@RequestMapping("/best.practices/stBestPractices")
@Slf4j
public class StBestPracticesController extends JeecgController<StBestPractices, IStBestPracticesService> {
	@Autowired
	private IStBestPracticesService stBestPracticesService;
	
	/**
	 * 分页列表查询
	 *
	 * @param stBestPractices
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "行业实践应用-分页列表查询")
	  
	@GetMapping(value = "/list")
	public Result<IPage<StBestPractices>> queryPageList(StBestPractices stBestPractices,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		IPage<StBestPractices> pageList = stBestPracticesService.defPage(stBestPractices,pageNo,pageSize,req.getParameterMap());
		return Result.OK(pageList);
	}
	
	/**
	 *   添加
	 *
	 * @param stBestPractices
	 * @return
	 */
	@AutoLog(value = "行业实践应用-添加")
	  
	@RequiresPermissions("best.practices:st_best_practices:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody StBestPractices stBestPractices) {
		stBestPracticesService.save(stBestPractices);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param stBestPractices
	 * @return
	 */
	@AutoLog(value = "行业实践应用-编辑")
	  
	@RequiresPermissions("best.practices:st_best_practices:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody StBestPractices stBestPractices) {
		stBestPracticesService.updateById(stBestPractices);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "行业实践应用-通过id删除")
	  
	@RequiresPermissions("best.practices:st_best_practices:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		stBestPracticesService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "行业实践应用-批量删除")
	  
	@RequiresPermissions("best.practices:st_best_practices:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.stBestPracticesService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "行业实践应用-通过id查询")
	  
	@GetMapping(value = "/queryById")
	public Result<StBestPractices> queryById(@RequestParam(name="id",required=true) String id) {
		StBestPractices stBestPractices = stBestPracticesService.getById(id);
		if(stBestPractices==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(stBestPractices);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param stBestPractices
    */
    @RequiresPermissions("best.practices:st_best_practices:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, StBestPractices stBestPractices) {
        return super.exportXls(request, stBestPractices, StBestPractices.class, "行业实践应用");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("best.practices:st_best_practices:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, StBestPractices.class);
    }

}
